unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, PaxCompiler, PaxProgram, PaxRegister, PaxJavaScriptLanguage;
type
  TForm1 = class(TForm)
    PaxCompiler1: TPaxCompiler;
    PaxProgram1: TPaxProgram;
    Button1: TButton;
    PaxJavaScriptLanguage1: TPaxJavaScriptLanguage;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    Y: Integer;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
  PAXCOMP_JavaScript;

procedure TForm1.Button1Click(Sender: TObject);
var
  I: Integer;
  P: Pointer;
  V: Variant;
  F: TJS_Function;
begin
{$O-}
  PaxCompiler1.Reset;
  PaxCompiler1.RegisterLanguage(PaxJavaScriptLanguage1);

  PaxCompiler1.RegisterVariable(0, 'Y', _typeINTEGER, @Y);

  PaxCompiler1.AddModule('1', PaxJavaScriptLanguage1.LanguageName);
  PaxCompiler1.AddCode('1', 'function P(U, V)');
  PaxCompiler1.AddCode('1', '{');
  PaxCompiler1.AddCode('1', '  Y = Y + U + V;');
  PaxCompiler1.AddCode('1', '  return Y;');
  PaxCompiler1.AddCode('1', '}');

  if PaxCompiler1.Compile(PaxProgram1) then
  begin
    PaxProgram1.Run; // to create Function objects

    P := PaxProgram1.GetAddress('P');
    F := TJS_Function(P^);
    V := F.Invoke([10, 20]);
    ShowMessage(IntToStr(Y));
  end
  else
    for I:=0 to PaxCompiler1.ErrorCount do
      ShowMessage(PaxCompiler1.ErrorMessage[I]);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Y := 5;
end;

end.
