{$APPTYPE CONSOLE}
{$O-}
program Project1;
uses
  PAXCOMP_CONSTANTS,
  PAXCOMP_SYS,
  TypInfo,
  Classes,
  SysUtils,
  IMPORT_Classes,
  PaxCompiler,
  PaxProgram,
  PaxRegister,
  IMPORT_TypInfo in 'IMPORT_TypInfo.pas';

type
  TTestClass = class
    procedure DoTest;
    procedure OnClickHandler(Sender: TObject);
    procedure OnClickHandler2(Sender: TObject);
  end;

var
  PaxProgram1: TPaxProgram;

procedure TTestClass.OnClickHandler(Sender: TObject);
begin
  writeln('Click');
end;

procedure TTestClass.OnClickHandler2(Sender: TObject);
begin
  writeln('Click 2');
end;


procedure TTestClass.DoTest;
var
  C: TClass;
  P: Pointer;
  pti: PTypeInfo;
  ptd: PTypeData;
  ppi: PPropInfo;
  I: Integer;
  Z, X: TObject;
  S: String;
  AMethod: TMethod;
begin
  AMethod.Code := @ TTestClass.OnClickHandler;
  AMethod.Data := Self;

  P := PaxProgram1.GetAddress('MyProg.TMyClass');
  C := TClass(P^);
  writeln(C.ClassName);
  pti := C.ClassInfo;
  writeln(pti^.Name);

  ptd := GetTypeData(pti);
  writeln(ptd^.ClassType.ClassName);
  pti := ptd^.ParentInfo^;
  writeln(pti^.Name);
  writeln(ptd^.PropCount);
  writeln(ptd^.UnitName);

  ppi := GetPropInfo(C, 'X');
  writeln(ppi^.Name);

  pti := PaxProgram1.GetTypeInfo('IUnknown');
  writeln(pti^.Name);
  ptd := GetTypeData(pti);
  writeln(ptd^.IntfUnit);

  pti := PaxProgram1.GetTypeInfo('MyProg.TCharSet');
  writeln(pti^.Name);
  ptd := GetTypeData(pti);
  if ptd <> nil then
    writeln(ptd^.CompType^.Name);

  pti := PaxProgram1.GetTypeInfo('MyProg.TMyEnum');
  writeln(pti^.Name);
  ptd := GetTypeData(pti);
  writeln(ptd^.BaseType^.Name);
//  writeln(ptd^.EnumUnitName);
  writeln(GetEnumName(pti, 2));
  writeln(GetEnumValue(pti, 'three'));

  pti := PaxProgram1.GetTypeInfo('Integer');
  writeln(pti^.Name);

  // work with instance

  P := PaxProgram1.GetAddress('MyProg.Z');
  Z := TObject(P^);
  writeln(Z.ClassName);
  SetOrdProp(Z, 'X', 5);
  I := GetOrdProp(Z, 'X');
  writeln(I);

  SetStrProp(Z, 'Y', 'abc');
  S := GetStrProp(Z, 'Y');
  writeln(S);

  ppi := GetPropInfo(Z, 'Inter');
  writeln(ppi^.Name);

  P := Z.MethodAddress('MyProc');
  asm
    call P;
  end;

  P := Z.FieldAddress('Field2');
  X := TObject(P^);
  writeln(X.ClassName);

  SetMethodProp(Z, 'OnClick', AMethod);
  AMethod := GetMethodProp(Z, 'OnClick');

  asm
    call AMethod.Code;
  end;

  // RTTI of inherited class:

  P := PaxProgram1.GetAddress('MyProg.TMyClass2');
  C := TClass(P^);
  writeln(C.ClassName);
  pti := C.ClassInfo;
  writeln(pti^.Name);

  ppi := GetPropInfo(C, 'X');
  writeln(ppi^.Name);

  // work with instance
  P := PaxProgram1.GetAddress('MyProg.W');
  Z := TObject(P^);
  writeln(Z.ClassName);
  SetOrdProp(Z, 'X', 7);
  I := GetOrdProp(Z, 'X');
  writeln(I);

  P := Z.MethodAddress('MyProc');
  asm
    call P;
  end;

  P := Z.FieldAddress('Field2');
  X := TObject(P^);
  writeln(X.ClassName);
end;

var
  PaxCompiler1: TPaxCompiler;
  PaxPascalLanguage1: TPaxPascalLanguage;
  H: Integer;
begin
  Register_Classes;
  Register_TypInfo;
  RegisterRTTIType(0, TypeInfo(TNotifyEvent));

  H := RegisterClassType(0, TTestClass);
  RegisterHeader(H, 'procedure DoTest;',
    @TTestClass.DoTest);
  RegisterHeader(H, 'procedure OnClickHandler2(Sender: TObject);',
    @TTestClass.OnClickHandler2);

  PaxCompiler1 := TPaxCompiler.Create(nil);
  PaxProgram1 := TPaxProgram.Create(nil);
  PaxPascalLanguage1 := TPaxPascalLanguage.Create(nil);
  try
    PaxCompiler1.RegisterLanguage(PaxPascalLanguage1);
    PaxCompiler1.AddModule('1', 'Pascal');
    PaxCompiler1.AddCodeFromFile('1', 'script.txt');
    if PaxCompiler1.Compile(PaxProgram1) then
    begin
{
      PaxProgram1.SaveToFile('1.bin');
      PaxProgram1.Free;
      PaxProgram1 := TPaxProgram.Create(nil);
      PaxProgram1.LoadFromFile('1.bin');
}
      PaxProgram1.Run;
    end
    else
      writeln(PaxCompiler1.ErrorMessage[0]);
  finally
    PaxCompiler1.Free;
    PaxProgram1.Free;
    PaxPascalLanguage1.Free;
  end;
  writeln('Press any key...');
  Readln;
end.
